from glob import glob
from time import sleep
import pygame
import spotipy
from spotipy.oauth2 import SpotifyOAuth
from dotenv import load_dotenv
from PIL import Image
import requests
from urllib.request import urlopen
import io

def inits():
    global currentURL, imgdef, playbackstate, BLUE, RED, sysfont, font, target_size, display_surface, REFRESHEVENT, scope, angle, mask, sp
    pygame.init()
    clock = pygame.time.Clock()
    load_dotenv()
    currentURL="AAAA"
    imgdef=640
    playbackstate = {}
    BLUE = (0, 0, 255)
    RED = (255, 0, 0)
    sysfont = pygame.font.get_default_font()
    font = pygame.font.SysFont(None, 48)
    print('system font :', sysfont)
    target_size = min(pygame.display.Info().current_h,pygame.display.Info().current_w)
    print(target_size)
    display_surface = pygame.display.set_mode((target_size,target_size))
    REFRESHEVENT = pygame.USEREVENT + 1
    pygame.time.set_timer(REFRESHEVENT, 5000)
    scope = "user-read-currently-playing"
    sp = spotipy.Spotify(auth_manager=SpotifyOAuth(scope=scope))
    angle = 0 
    print("-- creating mask")
    mask = pygame.Surface((imgdef, imgdef), pygame.SRCALPHA)
    pygame.draw.circle(mask,pygame.Color("white"),(imgdef/2,imgdef/2),imgdef/2)
    print("-- done creating mask")

def blitRotate(surf, image, pos, originPos, angle):
    #print("blitRotate")
    # offset from pivot to center
    image_rect = image.get_rect(topleft = (pos[0] - originPos[0], pos[1]-originPos[1]))
    offset_center_to_pivot = pygame.math.Vector2(pos) - image_rect.center
    
    # roatated offset from pivot to center
    rotated_offset = offset_center_to_pivot.rotate(-angle)

    # roatetd image center
    rotated_image_center = (pos[0] - rotated_offset.x, pos[1] - rotated_offset.y)

    # get a rotated image
    rotated_image = pygame.transform.rotate(image, angle)
    rotated_image_rect = rotated_image.get_rect(center = rotated_image_center)

    # rotate and blit the image
    surf.blit(rotated_image, rotated_image_rect)

def getCover():
    global currentURL, image, playbackstate
    print("-- getCover")
    try:
        playbackstate = sp.current_user_playing_track()
        
        #print(playbackstate)
        if(playbackstate):
            type = playbackstate['currently_playing_type']
            if(type == "track"):
                url =  playbackstate['item']['album']['images'][0]['url']
                #print(url)
                if(url != currentURL):
                    print("-- New image")
                    currentURL = url
                    image = DownloadCover(currentURL)
                else:
                    print("-- Same image")            
            if(type=="episode"):
                print("-- podcast")
                image = generateCover()
        else:
            print("-- Pb empty")
            image = generateCover()
        return image            

    except:
        print("-- An exception occurred") 
        image = generateCover()
        print(playbackstate)

def DownloadCover(url):
    print("-- Now downloading")
    response = requests.get(url)
    image_str = urlopen(url).read()
    image_file = io.BytesIO(image_str)
    image = pygame.image.load(image_file)
    print("-- Done downloading")
    return image

def generateCover():
    cover = pygame.Surface((imgdef, imgdef), pygame.SRCALPHA)
    font = pygame.font.SysFont(None, 48)
    img = font.render(sysfont, True, RED)
    rect = img.get_rect()
    pygame.draw.rect(img, BLUE, rect, 1)
    cover.fill(BLUE)
    cover.blit(img, (20, 20))
    print("-- Generated")
    return cover

inits()
img = getCover()

while True:
    #clock.tick(60)
    for event in pygame.event.get():
        if event.type == REFRESHEVENT:
            print("-- refresh")
            img = getCover()
        if event.type == pygame.QUIT:
            pygame.quit()
            raise SystemExit
    if(img):
       #print("-- if img") 
       masked = img.copy()
       masked.blit(mask, (0, 0), None, pygame.BLEND_RGBA_MULT)
       #display_surface.blit(masked,(0,0))
       pygame.draw.circle(masked,pygame.Color("black"),(imgdef/2,imgdef/2),imgdef/2-15,9)
       blitRotate(display_surface, masked, (target_size/2,target_size/2), (imgdef/2, imgdef/2), angle)
       if(playbackstate and playbackstate['is_playing'] == True):
           angle+=1
#        pygame.draw.circle(display_surface, pygame.Color(255, 255, 255), (target_size/2,target_size/2), 150, 0)
    pygame.display.flip()